<?php
if (!defined('FORUM_ROOT'))
	die();

require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

$section = isset($_GET['section']) ? $_GET['section'] : null;
$sort_by = isset($_GET['sort_by']) ? 'sort_by='.$_GET['sort_by'] : '';
$qs_keywords = (isset($_GET['key']) && is_string($_GET['key'])) ? forum_trim($_GET['key']) : '';

require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (!isset($lang_visits_statistic)) 
{
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
	    require $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
    else
	    require $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';
}

$flags_ext = ($forum_db->table_exists('flags') && $forum_db->field_exists('flags', 'code')) ? true : false;
if ($flags_ext)
{
    if (!isset($lang_flags)) {
        if (file_exists(FORUM_ROOT.'extensions/national_flags/lang/'.$forum_user['language'].'/flags.php') )
		    require FORUM_ROOT.'extensions/national_flags/lang/'.$forum_user['language'].'/flags.php';
	    else
		    require FORUM_ROOT.'extensions/national_flags/lang/English/flags.php';
    }
}

vs_delete_old_entries();
$disp_visits = $forum_user['disp_topics'];

$like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';

if ($section == 'now')
{
    $query_all = array(
	    'SELECT'	=> 'COUNT(o.user_id)',
	    'FROM'		=> 'online AS o',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'visits_statistic AS v',
				'ON'		    => 'v.token=o.csrf_token AND v.user_id=o.user_id AND v.url=o.prev_url',
			),
			array(
				'LEFT JOIN'		=> 'users AS u',
				'ON'		    => 'u.id=o.user_id',
			)
		),
        'WHERE'     => 'v.date IS NOT NULL',
		'GROUP BY'  => 'v.user_id'
    );

	if ($sort_by != '')
	{ 
		if ($sort_by == 'sort_by=country_ASC') {
			$query_all['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
		} else if($sort_by == 'sort_by=country_DESC') {
		    $query_all['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
	    } else if($sort_by == 'sort_by=username_ASC') {
			$query_all['WHERE'] .= ' AND o.user_id > 1';
		} else if($sort_by == 'sort_by=username_DESC') {
		    $query_all['WHERE'] .= ' AND o.user_id > 1';
	    } else if($sort_by == 'sort_by=users') {
		    $query_all['WHERE'] .= ' AND o.user_id > 1';
		} else if($sort_by == 'sort_by=guests') {
		    $query_all['WHERE'] .= ' AND o.user_id < 2';
			$query_all['GROUP BY'] .= ', v.ip_address';
		}
	}
	if ($qs_keywords != '')
	{
		if (isset($query_all['WHERE']))
			$query_all['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR o.prev_url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
		else
		    $query_all['WHERE'] = 'u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR o.prev_url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\'';
	}

    $result_all = $forum_db->query_build($query_all) or error(__FILE__, __LINE__);

	$num_visits = $forum_db->num_rows($result_all);
	
	//Page Navigation
	$forum_page['num_pages'] = ceil($num_visits / $disp_visits);
	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	$forum_page['start_from'] = $disp_visits * ($forum_page['page'] - 1);
	$forum_page['finish_at'] = min(($forum_page['start_from'] + $disp_visits), ($num_visits));
	$forum_page['items_info'] = generate_items_info($lang_visits_statistic['Pages'], ($forum_page['start_from'] + 1), $num_visits);
    $page_link = $forum_url['visits_statistic'].$section.((!empty($sort_by)) ? '&'.$sort_by : '').((!empty($qs_keywords)) ? '&amp;key='.$qs_keywords : '');

	if ($forum_page['num_pages'] > 1)
	    $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_visits_statistic['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $page_link, '', '', 1).'</p>';

	//Modify url by get request
	if (!empty($sort_by) && !empty($qs_keywords))
    {
		$last_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, 1));
	} else if (!empty($sort_by) || !empty($qs_keywords)) {
	    $last_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), 1));
	} else {
	    $last_link = forum_link($forum_url['visits_statistic_navi'], array($section, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_navi'], array($section, 1));
	}
	
	// Navigation links for header and page numbering for title/meta description
	if ($forum_page['page'] < $forum_page['num_pages'])
	{
		$forum_page['nav']['last'] = '<link rel="last" href="'.$last_link.'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
		$forum_page['nav']['next'] = '<link rel="next" href="'.$next_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
	}
	if ($forum_page['page'] > 1)
	{
		$forum_page['nav']['prev'] = '<link rel="prev" href="'.$prev_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
		$forum_page['nav']['first'] = '<link rel="first" href="'.$first_link.'" title="'.$lang_common['Page'].' 1" />';
	}

    // Setup breadcrumbs
    $forum_page['crumbs'] = array(
	    array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	    array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	    array($lang_visits_statistic['Visits statistic'], forum_link($forum_url['visits_statistic_list'], 'now')),
	    $lang_visits_statistic['Active now']
    );

    define('FORUM_PAGE_SECTION', 'visits_statistic');
    define('FORUM_PAGE', 'admin-visits_statistic_now');
    require FORUM_ROOT.'header.php';

    // START SUBST - <!-- forum_main -->
    ob_start();

    if($num_visits > 0) 
    {
	    if($sort_by == 'sort_by=visit_DESC')
		    $sort_query = 'last_active DESC';
	    else if($sort_by == 'sort_by=visit_ASC')
		    $sort_query = 'last_active ASC';
	    else if($sort_by == 'sort_by=country_ASC')
		    $sort_query = 'country ASC';
	    else if($sort_by == 'sort_by=country_DESC')
		    $sort_query = 'country DESC';
	    else if($sort_by == 'sort_by=user_agent_ASC')
		    $sort_query = 'user_agent ASC';
	    else if($sort_by == 'sort_by=user_agent_DESC')
		    $sort_query = 'user_agent DESC';
	    else if($sort_by == 'sort_by=username_ASC')
		    $sort_query = 'username ASC';
	    else if($sort_by == 'sort_by=username_DESC')
		    $sort_query = 'username DESC';
	    else if($sort_by == 'sort_by=users')
		    $sort_query = 'username ASC';
	    else if($sort_by == 'sort_by=guests')
		    $sort_query = 'last_active DESC';
	    else
		    $sort_query = 'last_active DESC';

	    $query = array(
		    'SELECT'	=> 'o.user_id, o.prev_url, v.ip_address, v.user_agent, v.title, MAX(v.date) AS last_active, u.username',
		    'FROM'		=> 'online AS o',
			'JOINS'		=> array(
				array(
				    'LEFT JOIN'		=> 'visits_statistic AS v',
				    'ON'		    => 'v.token=o.csrf_token AND v.user_id=o.user_id AND v.url=o.prev_url',
			    ),
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=o.user_id',
			    )
		    ),
			'WHERE'     => 'v.date IS NOT NULL',
			'GROUP BY'  => 'v.user_id',
            'ORDER BY'	=> $sort_query,
		    'LIMIT'		=> $forum_page['start_from'].', '.$disp_visits
	    );

		if ($flags_ext)
        {
		    $query['SELECT'] .= ', f.name AS country_name, f.image AS flag';
			$query['JOINS'][]	= array(
				'LEFT JOIN'		=> 'flags AS f',
				'ON'			=> 'f.code=v.country'
			);
		}
	    if ($sort_by != '')
	    {
			if ($sort_by == 'sort_by=country_ASC') {
			   $query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
			} else if($sort_by == 'sort_by=country_DESC') {
		       $query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
	        } else if ($sort_by == 'sort_by=username_ASC') {
			   $query['WHERE'] .= ' AND o.user_id > 1';
			} else if($sort_by == 'sort_by=username_DESC') {
		       $query['WHERE'] .= ' AND o.user_id > 1';
	        } else if($sort_by == 'sort_by=users') {
		       $query['WHERE'] .= ' AND o.user_id > 1';
			} else if($sort_by == 'sort_by=guests') {
		       $query['WHERE'] .= ' AND o.user_id < 2';
			   $query['GROUP BY'] .= ', v.ip_address';
			}
	    }
	    if ($qs_keywords != '')
	    {
		    if (isset($query['WHERE']))
			    $query['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR o.prev_url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
			else
				$query['WHERE'] = 'u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR o.prev_url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\'';
	    }
	
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
	    <div class="main-content main-frm" style="margin-bottom: 0;">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All visits'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Statistic_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>
			        <option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
		        </select>
		    </div>
		    <table>
			    <thead>
				    <tr>
					    <th class="tc1" style="width:20%;"><?php echo $lang_visits_statistic['Visitor'] ?></th>
<?php						
						if ($flags_ext) {
?>
						    <th class="tc2" style="width:45px;"><?php echo $lang_visits_statistic['Country'] ?></th>
<?php						
						}
?>
					    <th class="tc3"><?php echo $lang_visits_statistic['Link'] ?></th>
					    <th class="tc4" style="width:18%;"><?php echo $lang_visits_statistic['Agent'] ?></th>
					    <th class="tc5" style="width:123px;"><?php echo $lang_visits_statistic['Visiting time'] ?></th>
				    </tr>
			    </thead>
			    <tbody>
<?php
	            while ($visitor = $forum_db->fetch_assoc($result)) 
	            {
					if (empty($visitor['username'])) {$username = $lang_visits_statistic['User deleted'];} elseif ($visitor['username'] == 'Guest') {$username = $visitor['ip_address'];} else {$username = '<a href="'.forum_link($forum_url['user'], $visitor['user_id']).'" target="_blank">'.$visitor['username'].'</a>';}
					if ($flags_ext) {
					    $country_name = (isset($visitor['country_name']) && $lang_flags[$visitor['country_name']] != '') ? $lang_flags[$visitor['country_name']] : $visitor['country_name'];
					    $country_flag = '<img src="'.$base_url.'/extensions/national_flags/css/flags/'.$visitor['flag'].'" alt="" title="'.$country_name.'" style="vertical-align: bottom;">';
					}
?>
			        <tr>
					    <td class="tc1"><?php echo $username ?></td>
<?php						
						if ($flags_ext) {
?>
					        <td class="tc2"><?php echo $country_flag ?></td>
<?php						
						}
?>
					    <td class="tc3"><a href="<?php echo $visitor['prev_url'] ?>" target="_blank"><?php echo $visitor['title']; ?></a></td>
						<td class="tc4"><?php echo $visitor['user_agent']; ?></td>
						<td class="tc5"><?php echo format_time($visitor['last_active']); ?></td>
				    </tr>
<?php
	            }
?>
			    </tbody>
		    </table>
	    </div>
<?php
	} else {
?> 
	    <div class="main-content main-frm">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All visits'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Statistic_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>
			        <option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
		        </select>
		    </div>
		    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
			    <p><strong><?php echo $lang_visits_statistic['No activity'] ?></strong></p>
		    </div>
	    </div>
<?php 
    }
?>
    <script>
        function Statistic_sort_by(sel) {
	        var url = sel.getAttribute('url');
	        var sort_by = sel.value;
            var cur_sort = pd_get_param(url, 'sort_by');
			
			if (!cur_sort)
	            window.location.replace(url + '&' + sort_by);
			else
				window.location.replace(url.replace('sort_by='+cur_sort, sort_by));
        }
		function pd_get_param(url,key) {
	        s = url.match(new RegExp(key + '=([^&=]+)'));
	        return s ? s[1] : false;
        }
    </script>
<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';
}
else if (in_array($section, ['today', 'week', 'month']))
{
	$query = array(
	    'SELECT'    => 'v.id',
	    'FROM'	    => 'visits_statistic AS v',
		'JOINS'		=> array(
		    array(
				'LEFT JOIN'		=> 'users AS u',
				'ON'		    => 'u.id=v.user_id',
		    )
		),
    );

	if ($section == 'today') {
		$query['WHERE'] = 'v.date_small=\''.$forum_db->escape(date('Y-m-d')).'\'';
	} else if ($section == 'week') {
		$query['WHERE'] = 'v.date >'.(time()-604800);
	} else if ($section == 'month') {
		$query['WHERE'] = 'v.date >'.(time()-2629743);
	}
	if ($sort_by != '')
	{
		if ($sort_by == 'sort_by=country_ASC') {
			$query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
		} else if($sort_by == 'sort_by=country_DESC') {
		    $query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
	    } else if($sort_by == 'sort_by=username_ASC') {
			$query['WHERE'] .= ' AND v.user_id > 1';
		} else if($sort_by == 'sort_by=username_DESC') {
		    $query['WHERE'] .= ' AND v.user_id > 1';
	    } else if($sort_by == 'sort_by=users') {
		    $query['WHERE'] .= ' AND v.user_id > 1';
		    $query['GROUP BY'] = 'v.user_id';
		} else if($sort_by == 'sort_by=guests') {
		    $query['WHERE'] .= ' AND v.user_id < 2';
			$query['GROUP BY'] = 'v.ip_address';
		} else if ($sort_by == 'sort_by=users_by_ip') {
			$query['WHERE'] .= ' AND v.user_id > 1';
			$query['GROUP BY'] = 'v.ip_address, v.user_id';
		} else if ($sort_by == 'sort_by=countries') {
			$query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
			$query['GROUP BY'] = 'v.country';
		} else if ($sort_by == 'sort_by=user_agents') {
			$query['GROUP BY'] = 'v.user_agent';
		}
	}
	if ($qs_keywords != '')
	{
		$query['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
	}

    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

    $num_visits = $forum_db->num_rows($result);
	
	//Page Navigation
	$forum_page['num_pages'] = ceil($num_visits / $disp_visits);
	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	$forum_page['start_from'] = $disp_visits * ($forum_page['page'] - 1);
	$forum_page['finish_at'] = min(($forum_page['start_from'] + $disp_visits), ($num_visits));
	$forum_page['items_info'] = generate_items_info($lang_visits_statistic['Pages'], ($forum_page['start_from'] + 1), $num_visits);
    $page_link = $forum_url['visits_statistic'].$section.((!empty($sort_by)) ? '&'.$sort_by : '').((!empty($qs_keywords)) ? '&amp;key='.$qs_keywords : '');

	if ($forum_page['num_pages'] > 1)
	    $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_visits_statistic['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $page_link, '', '', 1).'</p>';

	//Modify url by get request
	if (!empty($sort_by) && !empty($qs_keywords))
    {
		$last_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, 1));
	} else if (!empty($sort_by) || !empty($qs_keywords)) {
	    $last_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), 1));
	} else {
	    $last_link = forum_link($forum_url['visits_statistic_navi'], array($section, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_navi'], array($section, 1));
	}
	
	// Navigation links for header and page numbering for title/meta description
	if ($forum_page['page'] < $forum_page['num_pages'])
	{
		$forum_page['nav']['last'] = '<link rel="last" href="'.$last_link.'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
		$forum_page['nav']['next'] = '<link rel="next" href="'.$next_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
	}
	if ($forum_page['page'] > 1)
	{
		$forum_page['nav']['prev'] = '<link rel="prev" href="'.$prev_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
		$forum_page['nav']['first'] = '<link rel="first" href="'.$first_link.'" title="'.$lang_common['Page'].' 1" />';
	}
	
	if ($section == 'today') {
		$page_title = $lang_visits_statistic['Activity per day'];
	} else if ($section == 'week') {
		$page_title = $lang_visits_statistic['Activity per week'];
	} else if ($section == 'month') {
		$page_title = $lang_visits_statistic['Activity per month'];
	}

    // Setup breadcrumbs
    $forum_page['crumbs'] = array(
	    array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	    array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	    array($lang_visits_statistic['Visits statistic'], forum_link($forum_url['visits_statistic_list'], 'now')),
	    $page_title
    );

    define('FORUM_PAGE_SECTION', 'visits_statistic');
    define('FORUM_PAGE', 'admin-visits_statistic_'.$section);
    require FORUM_ROOT.'header.php';

    // START SUBST - <!-- forum_main -->
    ob_start();

    if($num_visits > 0) 
    {
	    if($sort_by == 'sort_by=visit_DESC')
		    $sort_query = 'date DESC';
	    else if($sort_by == 'sort_by=visit_ASC')
		    $sort_query = 'date ASC';
	    else if($sort_by == 'sort_by=country_ASC')
		    $sort_query = 'country ASC, date DESC';
	    else if($sort_by == 'sort_by=country_DESC')
		    $sort_query = 'country DESC, date DESC';
	    else if($sort_by == 'sort_by=user_agent_ASC')
		    $sort_query = 'user_agent ASC, date DESC';
	    else if($sort_by == 'sort_by=user_agent_DESC')
		    $sort_query = 'user_agent DESC, date DESC';
	    else if($sort_by == 'sort_by=username_ASC')
		    $sort_query = 'username ASC, date DESC';
	    else if($sort_by == 'sort_by=username_DESC')
		    $sort_query = 'username DESC, date DESC';
	    else if($sort_by == 'sort_by=users')
		    $sort_query = 'username ASC';
	    else if($sort_by == 'sort_by=guests')
		    $sort_query = 'INET_ATON(ip_address)';
		else if($sort_by == 'sort_by=users_by_ip')
		    $sort_query = 'INET_ATON(ip_address)';
		else if($sort_by == 'sort_by=countries')
		    $sort_query = 'country ASC';
		else if($sort_by == 'sort_by=user_agents')
		    $sort_query = 'user_agent ASC';
	    else
		    $sort_query = 'date DESC';

	    $query = array(
		    'SELECT'	=> 'v.*, u.username',
		    'FROM'		=> 'visits_statistic AS v',
			'JOINS'		=> array(
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=v.user_id',
			    )
		    ),
		    'ORDER BY'	=> $sort_query,
		    'LIMIT'		=> $forum_page['start_from'].', '.$disp_visits
	    );
		
		if ($section == 'today') {
		    $query['WHERE'] = 'v.date_small=\''.$forum_db->escape(date('Y-m-d')).'\'';
	    } else if ($section == 'week') {
		    $query['WHERE'] = 'v.date >'.(time()-604800);
	    } else if ($section == 'month') {
		    $query['WHERE'] = 'v.date >'.(time()-2629743);
	    }
		if ($flags_ext)
        {
		    $query['SELECT'] .= ', f.name AS country_name, f.image AS flag';
			$query['JOINS'][]	= array(
				'LEFT JOIN'		=> 'flags AS f',
				'ON'			=> 'f.code=v.country'
			);
		}
	    if ($sort_by != '')
	    { 
			if ($sort_by == 'sort_by=country_ASC') {
			    $query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
			} else if($sort_by == 'sort_by=country_DESC') {
		        $query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
	        } else if($sort_by == 'sort_by=username_ASC') {
			    $query['WHERE'] .= ' AND v.user_id > 1';
			} else if($sort_by == 'sort_by=username_DESC') {
		        $query['WHERE'] .= ' AND v.user_id > 1';
	        } else if($sort_by == 'sort_by=users') {
				$query['SELECT'] .= ', MAX(v.date) AS last_active';
				$query['WHERE'] .= ' AND v.user_id > 1';
		        $query['GROUP BY'] = 'v.user_id';
			} else if($sort_by == 'sort_by=guests') {
				$query['SELECT'] .= ', MAX(v.date) AS last_active';
		        $query['WHERE'] .= ' AND v.user_id < 2';
			    $query['GROUP BY'] = 'v.ip_address';
			} else if ($sort_by == 'sort_by=users_by_ip') {
//			    $query['SELECT'] .= ', count(v.id) as cnt';
                $query['SELECT'] .= ', MAX(v.date) AS last_active';
				$query['WHERE'] .= ' AND v.user_id > 1';
			    $query['GROUP BY'] = 'v.ip_address, v.user_id';
		    } else if ($sort_by == 'sort_by=countries') {
			    $query['SELECT'] .= ', MAX(v.date) AS last_active';
				$query['WHERE'] .= ' AND v.country IS NOT NULL AND v.country != ""';
			    $query['GROUP BY'] = 'v.country';
		    } else if ($sort_by == 'sort_by=user_agents') {
			    $query['SELECT'] .= ', MAX(v.date) AS last_active';
				$query['GROUP BY'] = 'v.user_agent';
		    }
	    }
	    if ($qs_keywords != '')
	    {
		    $query['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.url '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.title '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR v.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
	    }
	
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
	    <div class="main-content main-frm" style="margin-bottom: 0;">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All visits'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Statistic_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>
			        <option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
					<option value="sort_by=users_by_ip"<?php if ($sort_by == 'sort_by=users_by_ip') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort users by ip'] ?></option>
<?php						
					if ($flags_ext) {
?>					
					    <option value="sort_by=countries"<?php if ($sort_by == 'sort_by=countries') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by countries'] ?></option>
<?php						
					}
?>
					<option value="sort_by=user_agents"<?php if ($sort_by == 'sort_by=user_agents') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agents'] ?></option>
		        </select>
		    </div>
		    <table>
			    <thead>
				    <tr>
<?php						
						if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
							<th class="tc1" style="width:20%;"><?php if ($flags_ext && $sort_by == 'sort_by=countries') echo $lang_visits_statistic['Country']; else echo $lang_visits_statistic['Visitor']; ?></th>
<?php						
						}						
						if ($flags_ext) {
							if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
						        <th class="tc2" style="width:45px;"><?php if ($sort_by == '' || $sort_by != 'sort_by=countries') echo $lang_visits_statistic['Country']; else echo $lang_visits_statistic['Flag']; ?></th>
<?php						
						    }
						}
						if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
						    <th class="tc3"><?php if ($sort_by != '' && ($sort_by == 'sort_by=users' || $sort_by == 'sort_by=users_by_ip')) echo $lang_visits_statistic['User IP']; else if ($sort_by != '' && ($sort_by == 'sort_by=guests' || $sort_by == 'sort_by=countries')) echo ''; else echo $lang_visits_statistic['Link']; ?></th>
<?php						
						}
						if ($sort_by == '' || ($sort_by != 'sort_by=users' && $sort_by != 'sort_by=guests' && $sort_by != 'sort_by=users_by_ip' && $sort_by != 'sort_by=countries')) {
?>
						    <th class="tc4" <?php if ($sort_by == '' || $sort_by != 'sort_by=user_agents') echo 'style="width:18%;"'; ?>><?php echo $lang_visits_statistic['Agent']; ?></th>
<?php						
						}
?>
					    <th class="tc5" style="width:123px;"><?php echo $lang_visits_statistic['Visiting time'] ?></th>
				    </tr>
			    </thead>
			    <tbody>
<?php
	            while ($visitor = $forum_db->fetch_assoc($result)) 
	            {
					if (empty($visitor['username'])) {$username = $lang_visits_statistic['User deleted'];} elseif ($visitor['username'] == 'Guest') {$username = $visitor['ip_address'];} else {$username = '<a href="'.forum_link($forum_url['user'], $visitor['user_id']).'" target="_blank">'.$visitor['username'].'</a>';}
					if ($flags_ext) {
					    $country_name = (isset($visitor['country_name']) && $lang_flags[$visitor['country_name']] != '') ? $lang_flags[$visitor['country_name']] : $visitor['country_name'];
					    $country_flag = '<img src="'.$base_url.'/extensions/national_flags/css/flags/'.$visitor['flag'].'" alt="" title="'.$country_name.'" style="vertical-align: bottom;">';
					}
?>
			        <tr>
<?php						
						if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
							<td class="tc1"><?php if ($flags_ext && $sort_by == 'sort_by=countries') echo $country_name; else echo $username; ?></td>
<?php						
						}						
						if ($flags_ext) {
							if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
					            <td class="tc2"><?php echo $country_flag ?></td>
<?php						
						    }
						}
						if ($sort_by == '' || $sort_by != 'sort_by=user_agents') {
?>
					        <td class="tc3"><?php if ($sort_by != '' && ($sort_by == 'sort_by=users' || $sort_by == 'sort_by=users_by_ip')) echo $visitor['ip_address']; else if ($sort_by != '' && ($sort_by == 'sort_by=guests' || $sort_by == 'sort_by=countries')) echo ''; else echo '<a href="'.$visitor['url'].'" target="_blank">'.$visitor['title'].'</a>'; ?></td>
<?php						
	                    }
						if ($sort_by == '' || ($sort_by != 'sort_by=users' && $sort_by != 'sort_by=guests' && $sort_by != 'sort_by=users_by_ip' && $sort_by != 'sort_by=countries')) {
?>
						    <td class="tc4" style="width:18%;"><?php echo $visitor['user_agent']; ?></td>
<?php						
						}
?>
						<td class="tc5"><?php if ($sort_by != '' && ($sort_by == 'sort_by=users' || $sort_by == 'sort_by=guests' || $sort_by == 'sort_by=users_by_ip' || $sort_by == 'sort_by=countries' || $sort_by == 'sort_by=user_agents')) echo format_time($visitor['last_active']); else echo format_time($visitor['date']); ?></td>
				    </tr>
<?php
	            }
?>
			    </tbody>
		    </table>
	    </div>
<?php
	} else {
?> 
	    <div class="main-content main-frm">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All visits'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Statistic_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>
			        <option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
					<option value="sort_by=users_by_ip"<?php if ($sort_by == 'sort_by=users_by_ip') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort users by ip'] ?></option>
<?php						
					if ($flags_ext) {
?>
					    <option value="sort_by=countries"<?php if ($sort_by == 'sort_by=countries') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by countries'] ?></option>
<?php						
					}
?>
					<option value="sort_by=user_agents"<?php if ($sort_by == 'sort_by=user_agents') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agents'] ?></option>
		        </select>
		    </div>
		    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
			    <p><strong><?php echo $lang_visits_statistic['No visits'] ?></strong></p>
		    </div>
	    </div>
<?php 
    }
?>
    <script>
        function Statistic_sort_by(sel) {
	        var url = sel.getAttribute('url');
	        var sort_by = sel.value;
            var cur_sort = pd_get_param(url, 'sort_by');
			
			if (!cur_sort)
	            window.location.replace(url + '&' + sort_by);
			else
				window.location.replace(url.replace('sort_by='+cur_sort, sort_by));
        }
		function pd_get_param(url,key) {
	        s = url.match(new RegExp(key + '=([^&=]+)'));
	        return s ? s[1] : false;
        }
    </script>
<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';
}
else if ($section == 'logs')
{
	$query = array(
	    'SELECT'    => 'l.id',
	    'FROM'	    => 'users_activity_log AS l',
		'JOINS'		=> array(
		    array(
				'LEFT JOIN'		=> 'users AS u',
				'ON'		    => 'u.id=l.user_id',
		    )
		),
		'WHERE' => 'l.date >'.(time()-2629743),
    );

	if ($sort_by != '')
	{
		if ($sort_by == 'sort_by=country_ASC') {
			$query['WHERE'] .= ' AND l.country IS NOT NULL AND l.country != ""';
		} else if($sort_by == 'sort_by=country_DESC') {
		    $query['WHERE'] .= ' AND l.country IS NOT NULL AND l.country != ""';
	    } else if($sort_by == 'sort_by=username_ASC') {
			$query['WHERE'] .= ' AND l.user_id > 1';
		} else if($sort_by == 'sort_by=username_DESC') {
		    $query['WHERE'] .= ' AND l.user_id > 1';
	    } else if($sort_by == 'sort_by=users') {
		    $query['WHERE'] .= ' AND l.user_id > 1';
		    $query['GROUP BY'] = 'l.user_id';
		} else if($sort_by == 'sort_by=guests') {
		    $query['WHERE'] .= ' AND l.user_id < 2';
			$query['GROUP BY'] = 'l.ip_address';
		} else if($sort_by == 'sort_by=positive_result') {
		    $query['WHERE'] .= ' AND l.result < 1';
		} else if($sort_by == 'sort_by=negative_result') {
		    $query['WHERE'] .= ' AND l.result > 0';
		}
	}
	if ($qs_keywords != '')
	{
		$query['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.action '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.description '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
	}

    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

    $num_visits = $forum_db->num_rows($result);
	
	//Page Navigation
	$forum_page['num_pages'] = ceil($num_visits / $disp_visits);
	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	$forum_page['start_from'] = $disp_visits * ($forum_page['page'] - 1);
	$forum_page['finish_at'] = min(($forum_page['start_from'] + $disp_visits), ($num_visits));
	$forum_page['items_info'] = generate_items_info($lang_visits_statistic['Pages'], ($forum_page['start_from'] + 1), $num_visits);
    $page_link = $forum_url['visits_statistic'].$section.((!empty($sort_by)) ? '&'.$sort_by : '').((!empty($qs_keywords)) ? '&amp;key='.$qs_keywords : '');

	if ($forum_page['num_pages'] > 1)
	    $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_visits_statistic['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $page_link, '', '', 1).'</p>';

	//Modify url by get request
	if (!empty($sort_by) && !empty($qs_keywords))
    {
		$last_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by_and_qsearch'], array($section, $sort_by, $qs_keywords, 1));
	} else if (!empty($sort_by) || !empty($qs_keywords)) {
	    $last_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_sort_by'], array($section, ((!empty($sort_by)) ? $sort_by : $qs_keywords), 1));
	} else {
	    $last_link = forum_link($forum_url['visits_statistic_navi'], array($section, $forum_page['num_pages']));
		$next_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] + 1)));
		$prev_link = forum_link($forum_url['visits_statistic_navi'], array($section, ($forum_page['page'] - 1)));
		$first_link = forum_link($forum_url['visits_statistic_navi'], array($section, 1));
	}
	
	// Navigation links for header and page numbering for title/meta description
	if ($forum_page['page'] < $forum_page['num_pages'])
	{
		$forum_page['nav']['last'] = '<link rel="last" href="'.$last_link.'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
		$forum_page['nav']['next'] = '<link rel="next" href="'.$next_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
	}
	if ($forum_page['page'] > 1)
	{
		$forum_page['nav']['prev'] = '<link rel="prev" href="'.$prev_link.'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
		$forum_page['nav']['first'] = '<link rel="first" href="'.$first_link.'" title="'.$lang_common['Page'].' 1" />';
	}

    // Setup breadcrumbs
    $forum_page['crumbs'] = array(
	    array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	    array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	    array($lang_visits_statistic['Visits statistic'], forum_link($forum_url['visits_statistic_list'], 'now')),
	    $lang_visits_statistic['Event Log']
    );

    define('FORUM_PAGE_SECTION', 'visits_statistic');
    define('FORUM_PAGE', 'admin-visits_statistic_logs');
    require FORUM_ROOT.'header.php';

    // START SUBST - <!-- forum_main -->
    ob_start();

    if($num_visits > 0) 
    {
	    if($sort_by == 'sort_by=visit_DESC')
		    $sort_query = 'date DESC';
	    else if($sort_by == 'sort_by=visit_ASC')
		    $sort_query = 'date ASC';
	    else if($sort_by == 'sort_by=country_ASC')
		    $sort_query = 'country ASC';
	    else if($sort_by == 'sort_by=country_DESC')
		    $sort_query = 'country DESC';
	    else if($sort_by == 'sort_by=user_agent_ASC')
		    $sort_query = 'user_agent ASC';
	    else if($sort_by == 'sort_by=user_agent_DESC')
		    $sort_query = 'user_agent DESC';
	    else if($sort_by == 'sort_by=username_ASC')
		    $sort_query = 'username ASC';
	    else if($sort_by == 'sort_by=username_DESC')
		    $sort_query = 'username DESC';
	    else if($sort_by == 'sort_by=users')
		    $sort_query = 'username ASC';
	    else if($sort_by == 'sort_by=guests')
		    $sort_query = 'date DESC';
	    else
		    $sort_query = 'date DESC';

	    $query = array(
		    'SELECT'	=> 'l.*, u.username',
		    'FROM'		=> 'users_activity_log AS l',
			'JOINS'		=> array(
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=l.user_id',
			    )
		    ),
			'WHERE'     => 'l.date >'.(time()-2629743),
		    'ORDER BY'	=> $sort_query,
		    'LIMIT'		=> $forum_page['start_from'].', '.$disp_visits
	    );

		if ($flags_ext)
        {
		    $query['SELECT'] .= ', f.name AS country_name, f.image AS flag';
			$query['JOINS'][]	= array(
				'LEFT JOIN'		=> 'flags AS f',
				'ON'			=> 'f.code=l.country'
			);
		}
	    if ($sort_by != '')
	    { 
			if ($sort_by == 'sort_by=country_ASC') {
			   $query['WHERE'] .= ' AND l.country IS NOT NULL AND l.country != ""';
			} else if($sort_by == 'sort_by=country_DESC') {
		       $query['WHERE'] .= ' AND l.country IS NOT NULL AND l.country != ""';
	        } else if($sort_by == 'sort_by=username_ASC') {
			   $query['WHERE'] .= ' AND l.user_id > 1';
			} else if($sort_by == 'sort_by=username_DESC') {
		       $query['WHERE'] .= ' AND l.user_id > 1';
	        } else if($sort_by == 'sort_by=users') {
		       $query['WHERE'] .= ' AND l.user_id > 1';
		       $query['GROUP BY'] = 'l.user_id';
			} else if($sort_by == 'sort_by=guests') {
		       $query['WHERE'] .= ' AND l.user_id < 2';
			   $query['GROUP BY'] = 'l.ip_address';
			} else if($sort_by == 'sort_by=positive_result') {
		       $query['WHERE'] .= ' AND l.result < 1';
			} else if($sort_by == 'sort_by=negative_result') {
		       $query['WHERE'] .= ' AND l.result > 0';
			}
	    }
	    if ($qs_keywords != '')
	    {
		    $query['WHERE'] .= ' AND (u.username '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.action '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.description '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\' OR l.user_agent '.$like_command.' \'%'.$forum_db->escape($qs_keywords).'%\')';
	    }
	
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
	    <div class="main-content main-frm" style="margin-bottom: 0;">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All events'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Logs_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>
			        <option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
					<option value="sort_by=positive_result"<?php if ($sort_by == 'sort_by=positive_result') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by positive result'] ?></option>
					<option value="sort_by=negative_result"<?php if ($sort_by == 'sort_by=negative_result') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by negative result'] ?></option>
		        </select>
		    </div>
		    <table>
			    <thead>
				    <tr>
					    <th class="tc1" style="width:13%;"><?php echo $lang_visits_statistic['User'] ?></th>
<?php						
						if ($flags_ext) {
?>
						    <th class="tc2" style="width:45px;"><?php echo $lang_visits_statistic['Country'] ?></th>
<?php						
						}
?>
					    <th class="tc3" style="width:15%;"><?php echo $lang_visits_statistic['Event'] ?></th>
						<th class="tc4"><?php echo $lang_visits_statistic['Result'] ?></th>
					    <th class="tc5" style="width:18%;"><?php echo $lang_visits_statistic['Agent'] ?></th>
					    <th class="tc6" style="width:115px;"><?php echo $lang_visits_statistic['Event time'] ?></th>
				    </tr>
			    </thead>
			    <tbody>
<?php
	            while ($event = $forum_db->fetch_assoc($result)) 
	            {
					if (empty($event['username'])) {$username = $lang_visits_statistic['User deleted'];} elseif ($event['username'] == 'Guest') {$username = $event['ip_address'];} else {$username = '<a href="'.forum_link($forum_url['user'], $event['user_id']).'" target="_blank">'.$event['username'].'</a>';}
					if ($flags_ext) {
					    $country_name = (isset($event['country_name']) && $lang_flags[$event['country_name']] != '') ? $lang_flags[$event['country_name']] : $event['country_name'];
					    $country_flag = '<img src="'.$base_url.'/extensions/national_flags/css/flags/'.$event['flag'].'" alt="" title="'.$country_name.'" style="vertical-align: bottom;">';
					}
					$action_result = ($event['description'] != '') ? $event['description'] : $lang_visits_statistic['Success'];
					$desc_color = ($event['result'] == 0) ? 'green' : 'red';
?>
			        <tr>
					    <td class="tc1"><?php echo $username ?></td>
<?php						
						if ($flags_ext) {
?>
					        <td class="tc2"><?php echo $country_flag ?></td>
<?php						
						}
?>
					    <td class="tc3"><?php echo $lang_visits_statistic[$event['action']] ?></td>
						<td class="tc4" style="color: #fff; background-color: <?php echo $desc_color ?>;"><?php echo $action_result ?></td>
						<td class="tc5"><?php echo $event['user_agent']; ?></td>
						<td class="tc6"><?php echo format_time($event['date']); ?></td>
				    </tr>
<?php
	            }
?>
			    </tbody>
		    </table>
	    </div>
<?php
	} else {
?> 
	    <div class="main-content main-frm">
		    <div class="main-subhead" style="border:unset; border-bottom: 1px solid #d3dae1;">
		        <h2 class="hn"><span><?php echo sprintf($lang_visits_statistic['All events'], $num_visits); ?></span></h2>
			    <select id="statistic_sort_by" onchange="Logs_sort_by(this)" url="<?php echo $page_link ?>">
			        <option value="sort_by=visit_DESC"<?php if ($sort_by == 'sort_by=visit_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit desc'] ?></option>
			        <option value="sort_by=visit_ASC"<?php if ($sort_by == 'sort_by=visit_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by visit asc'] ?></option>
<?php						
					if ($flags_ext) {
?>			        
					    <option value="sort_by=country_ASC"<?php if ($sort_by == 'sort_by=country_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country asc'] ?></option>
		                <option value="sort_by=country_DESC"<?php if ($sort_by == 'sort_by=country_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by country desc'] ?></option>
<?php						
					}
?>			        
					<option value="sort_by=user_agent_ASC"<?php if ($sort_by == 'sort_by=user_agent_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent asc'] ?></option>
			        <option value="sort_by=user_agent_DESC"<?php if ($sort_by == 'sort_by=user_agent_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by user agent desc'] ?></option>
			        <option value="sort_by=username_ASC"<?php if ($sort_by == 'sort_by=username_ASC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username asc'] ?></option>
		            <option value="sort_by=username_DESC"<?php if ($sort_by == 'sort_by=username_DESC') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by username desc'] ?></option>
		            <option value="sort_by=users"<?php if ($sort_by == 'sort_by=users') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by users'] ?></option>
					<option value="sort_by=guests"<?php if ($sort_by == 'sort_by=guests') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by guests'] ?></option>
					<option value="sort_by=positive_result"<?php if ($sort_by == 'sort_by=positive_result') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by positive result'] ?></option>
					<option value="sort_by=negative_result"<?php if ($sort_by == 'sort_by=negative_result') echo ' selected="selected"' ?>><?php echo $lang_visits_statistic['Sort by negative result'] ?></option>
		        </select>
		    </div>
		    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
			    <p><strong><?php echo $lang_visits_statistic['No events'] ?></strong></p>
		    </div>
	    </div>
<?php 
    }
?>
    <script>
        function Logs_sort_by(sel) {
	        var url = sel.getAttribute('url');
	        var sort_by = sel.value;
            var cur_sort = pd_get_param(url, 'sort_by');
			
			if (!cur_sort)
	            window.location.replace(url + '&' + sort_by);
			else
				window.location.replace(url.replace('sort_by='+cur_sort, sort_by));
        }
		function pd_get_param(url,key) {
	        s = url.match(new RegExp(key + '=([^&=]+)'));
	        return s ? s[1] : false;
        }
    </script>
<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';
}